<template> 
  <div>
    <Toolbar />
    
    <v-content dark id="register">
        <v-layout row wrap style="top: 0">
            <v-flex xs12 md6 offset-md3 >
                <v-card class="card--flex-toolbar" >
                    <v-card-title class="subheading" prominent>
                        <v-layout>
                            <v-flex xs10>
                                <v-avatar slot="activator" size="36px">
                                  <img v-if="profile && profile.picture" :src="profile.picture" alt="Avatar">
                                  <v-icon v-else large color="primary">face</v-icon>
                                </v-avatar>
                                <span  v-if="profile" class="ml-2">{{profile.name}}</span>
                            </v-flex>
                        </v-layout>
                    </v-card-title>
                    <v-card-text>
                        <v-layout row wrap>
                            <v-flex xs12 class="mb-2 mt-2 subheading">
                                {{$i18n.t("account.registration.headline")}} 
                            </v-flex>
                            <v-flex xs12 sm4 :class="keyClass">{{$i18n.t("account.email")}}</v-flex>
                            <v-flex xs12 sm8 :class="valueClass" style="padding-left: 10px !important;"><span v-if="profile">{{profile.email}}</span></v-flex>
                            
                            <v-flex xs12 sm4 :class="keyClassLast" id="subscriptionHeader">
                                {{$i18n.t("account.subscription")}}
                                </v-flex>
                            <v-flex xs12 sm8 :class="valueClass + forceHeight + ' last radio'" dense>
                                <v-radio-group v-model="subscriptionPlan" :row="false" :class="radio" disabled> 
                                    <v-radio 
                                        v-for="(plan) in plans" 
                                       :label="plan" :value="plan" :key="plan" :selected="subscriptionPlan == plan"/>
                                </v-radio-group>
                            </v-flex>
                            <v-flex xs12>
                                <span class="caption"><a style="color: #999 !important;; text-decoration: none !important;" href="/plans">{{$i18n.t("plan.actions.compare")}}</a></span>
                            </v-flex>
                            <v-flex xs12 class="caption agreement dense-inputs mt-4">
                                  <v-checkbox v-model="termsOfUseAccepted">
                                     <template slot="label">
                                         <span>{{$i18n.t("legal.agree")}} <a @click.stop='termsAndConditionsDialog = true'>{{$i18n.t("legal.termsOfUse")}}</a></span>
                                     </template>
                                  </v-checkbox>     
                            </v-flex>
                            <v-flex xs12 class="caption agreement dense-inputs pt-0 mt-0"> 
                                <v-checkbox v-model="privacyPolicyAccepted">
                                     <template slot="label">
                                         <span>{{$i18n.t("legal.agree")}} <a @click.stop="privacyPolicyDialog = true">{{$i18n.t("legal.privacyPolicy")}} </a></span>
                                     </template>
                                </v-checkbox>     
                             </v-flex>
                            <v-flex xs12 class="text-xs-center mt-4 pt-4 mb-1 pb-1">
                                <v-btn :disabled="!termsOfUseAccepted || !privacyPolicyAccepted" large color="primary" dark @click="register">Register</v-btn>
                            </v-flex>
                        </v-layout>
                    </v-card-text>
               </v-card>
          </v-flex>
      </v-layout>
    </v-content>
    <v-dialog v-model="termsAndConditionsDialog" scrollable max-width="680px">
        <v-card>
            <v-card-title>
                <v-layout row wrap>
                    <v-flex xs12 class="display-1">
                        {{$i18n.t("legal.termsOfUse")}}
                    </v-flex>
                    <v-flex xs12 class="caption mt-2 pt-0" style="color: #999">
                        {{legalLastUpdate}}
                    </v-flex>
                </v-layout>
            </v-card-title>
            <v-card-text v-html='termsOfUse'></v-card-text>
            <v-card-actions><v-btn flat color="primary" class="text-xs-center" @click="termsAndConditionsDialog = false">{{$i18n.t("common.close")}}</v-btn></v-card-actions>
        </v-card>
    </v-dialog>
    <v-dialog v-model="privacyPolicyDialog" scrollable max-width="680px">
        <v-card>
            <v-card-title>
                <v-layout row wrap>
                    <v-flex xs12 class="display-1">
                        {{$i18n.t("legal.privacyPolicy")}}
                    </v-flex>
                    <v-flex xs12 class="caption mt-2 pt-0" style="color: #999">
                        {{legalLastUpdate}}
                    </v-flex>
                </v-layout>
            </v-card-title>
            <v-card-text v-html='privacyPolicy'></v-card-text>
            <v-card-actions><v-btn flat color="primary" class="text-xs-center" @click="privacyPolicyDialog = false">{{$i18n.t("common.close")}}</v-btn></v-card-actions>
        </v-card>
    </v-dialog>
  </div>
</template>

<script>
import moment from 'moment'
import axios from 'axios'
import Toolbar from '../components/Toolbar.vue'
export default {
  name: 'Register',
  components: { Toolbar },
  data() {
    return {
        profile: null,
        canSubscribe: null,
        subscriptionPlan: 'FISHER',
        plans: ['FISHER', 'HUNTER', 'SNIPER'],
        termsAndConditionsDialog: null,
        termsOfUse: null,
        privacyPolicyDialog: null,
        privacyPolicy: null,
        termsOfUseAccepted: null,
        privacyPolicyAccepted: null
    }
  },
  mounted() {
    this.profile = this.$auth.user;
    axios.get(`/resources/html/terms-of-use.${this.$i18n.locale}.html`).then((r) => this.termsOfUse = r.data)
    axios.get(`/resources/html/privacy-policy.${this.$i18n.locale}.html`).then((r) => this.privacyPolicy = r.data)
  },
  computed: {
    legalLastUpdate() {
        const dateFormat = this.$i18n.t("common.dateFormat")
        return this.$i18n.t("legal.lastUpdate", { date: moment({year: 2019, month: 1, day: 1}).format(dateFormat) });
    },
    valueClass() {
        return 'body-1 cell ' + (this.$vuetify.breakpoint.xs === true ? ' value-cell-xs' :  ' pt-3 mt-3 ')
    },
    keyClass() {
        return 'key pt-3 mt-3 cell ' + (this.$vuetify.breakpoint.xs === true ? ' key-cell-xs' : '')
    },
    keyClassLast() {
        return this.keyClass + ' last ' + (this.$vuetify.breakpoint.xs === true ? '' : 'pb-3 mb-3')
    },
    radio() {
        return 'pt-0 ' + (this.$vuetify.breakpoint.xs !== true ?  'mt-0 mb-0 pb-0 caption' : 'mt-1  mb-1 pb-1')
    },
    forceHeight() {
        return this.$vuetify.breakpoint.xs === true ?  ' ' : ' radio-sm';
    }
  },
  methods: {
    async register() {
        await this.$api.createUser(this.$i18n.locale)
        this.$router.replace({name: 'board'})
    }
  }
}
</script>

<style>
.cell {
  border-top: 1px #ccc solid;
}
.cell.last {
  border-bottom: 1px #ccc solid;
}
.value-cell-xs {
  border-top: none !important;  
}
.key-cell-xs.last {
  border-bottom: none !important;
}
.key {
  text-transform: uppercase;
  color: #2196F3;
  font-weight: bold;
}
#register .v-radio {
  margin-top: -2px !important;
}
#register .v-radio .v-label {
  font-size: 14px !important; 
}
#register .v-messages {
  display: none;
}
#register .v-radio i {
  font-size: 16px;
  line-height: 1.5;
  margin-left: 10px !important;
}
#subscriptionHeader {
  margin-bottom: 0px !important;
}
#agreement .v-input--selection-controls {
  margin-top: 0 !important;
  padding-top: 0 !important;
  margin-bottom: 0;
  padding-bottom: 0;
}
.agreement .v-input--selection-controls label { 
  font-size: 14px !important;
} 
.agreement .v-input--selection-controls .v-icon {  
  font-size: 16px !important;
  margin-top: 4px;
}
.agreement .v-input-checkbox {
  margin-top: 0;
  padding-top: 0;
}
</style>



